<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-store](./foundation-store.md) &gt; [AbstractStore](./foundation-store.abstractstore.md)

## AbstractStore class

The abstract store that concrete store fragments must extend, which differs from the [AbstractStoreRoot](./foundation-store.abstractstoreroot.md)<!-- -->.

**Signature:**

```typescript
export declare abstract class AbstractStore<TStore extends Store, TEventDetailMap extends EventDetailMap, TInternalEventDetailMap extends EventDetailMap = TEventDetailMap, TStoreRoot extends StoreRoot = StoreRoot> implements Store 
```
**Implements:** [Store](./foundation-store.store.md)

## Constructors

|  Constructor | Modifiers | Description |
|  --- | --- | --- |
|  [(constructor)(storeFragments)](./foundation-store.abstractstore._constructor_.md) |  | Constructs a new instance of the <code>AbstractStore</code> class |

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [commit](./foundation-store.abstractstore.commit.md) | <p><code>protected</code></p><p><code>readonly</code></p> | this | **_(BETA)_** The value commit proxy. |
|  [createAsyncListener](./foundation-store.abstractstore.createasynclistener.md) | <code>protected</code> | &lt;TDetail = void, TReturn = void&gt;(key: keyof (TEventDetailMap &amp; TInternalEventDetailMap), token: (detail: TDetail) =&gt; Promise&lt;TReturn&gt;) =&gt; EventListener | Creates an async event listener. |
|  [createErrorListener](./foundation-store.abstractstore.createerrorlistener.md) | <code>protected</code> | &lt;TDetail extends Error = Error&gt;(key: keyof (TEventDetailMap &amp; TInternalEventDetailMap), token?: (detail: TDetail) =&gt; void) =&gt; EventListener | Creates an error event listener. |
|  [createListener](./foundation-store.abstractstore.createlistener.md) | <code>protected</code> | &lt;TDetail = void&gt;(key: keyof (TEventDetailMap &amp; TInternalEventDetailMap), token: (detail: TDetail) =&gt; void) =&gt; EventListener | Creates an event listener. |
|  [errors](./foundation-store.abstractstore.errors.md) |  | [ErrorMap](./foundation-store.errormap.md)<!-- -->&lt;TEventDetailMap &amp; TInternalEventDetailMap&gt; | Contains any errors the store may have, see [ErrorMap](./foundation-store.errormap.md)<!-- -->. |
|  [name](./foundation-store.abstractstore.name.md) | <code>readonly</code> | string | The name of the store fragment. |
|  [root](./foundation-store.abstractstore.root.md) | <code>protected</code> | TStoreRoot | The store root fragment. |

## Methods

|  Method | Modifiers | Description |
|  --- | --- | --- |
|  [binding(token, subscriberChangeCallback, isVolatileBinding, context)](./foundation-store.abstractstore.binding.md) |  | An api to allow the observation of values and arbitrary bindings outside the template engine. |
|  [bindingAsRx()](./foundation-store.abstractstore.bindingasrx.md) |  |  |
|  [bindingAsRx(key)](./foundation-store.abstractstore.bindingasrx_1.md) |  |  |
|  [bindingAsRx(getter)](./foundation-store.abstractstore.bindingasrx_2.md) |  |  |
|  [commitValue(key, value)](./foundation-store.abstractstore.commitvalue.md) | <code>protected</code> | **_(BETA)_** Alternative value commit api. |
|  [connect(root)](./foundation-store.abstractstore.connect.md) |  | Connects this store fragment. |
|  [disconnect(root)](./foundation-store.abstractstore.disconnect.md) |  | Disconnects this store fragment. |
|  [emit(args)](./foundation-store.abstractstore.emit.md) | <code>protected</code> | Emit events to the stores directly via the standard event flow. |

